#include <iostream>
#include <sstream>
#include <string>
using namespace std;

// двухсвязный список

// from kernel: "/lib/modules/.../source/include/linux/list.h"
typedef struct list_head {
   struct list_head *next, *prev;
} list_head_t;

void INIT_LIST_HEAD( list_head_t *list ) {
   list->next = list;
   list->prev = list;
}

list_head_t* list_add_after( list_head_t *obj, list_head_t *node ) {
   node->next->prev = obj;
   obj->next = node->next;
   obj->prev = node;
   node->next = obj;
   return obj;
}

//--------------------------------------------------------------------

class node_double_t {
public:
   list_head_t link;
   int data;                            // собственные данные узла
   node_double_t( int val ) : data( val ) {
      INIT_LIST_HEAD( &link );
   };
};

void destroy( node_double_t *p ) {
   list_head_t *pl = (list_head_t*)p;
   do {
      list_head_t *pn = pl->next;
      delete pl;
      pl = pn; 
      cout << '-';
   } while( pl != (list_head_t*)p );
   cout << endl;
}

int main( int argc, char **argv ) {
   while( true ) {
      int size, i = 0;
      cout << "длина списка: ";
      cin >> size;
      node_double_t *head = new node_double_t( 0 );
      list_head_t *pc = (list_head_t*)head;
      do pc = list_add_after( (list_head_t*)new node_double_t( i++ + 1 ), pc );
      while( i < size - 1 );
      pc = (list_head_t*)head;
      do                         // обход кольцевого списка вперёд
         cout << ((node_double_t*)pc)->data << " , ";
      while( (pc = pc->next) != (list_head_t*)head );
      pc = pc->prev;
      do                         // обход кольцевого списка назад
         cout << ((node_double_t*)(pc->prev))->data << " , ";
      while( ( pc = pc->prev ) != (list_head_t*)head );
      cout << endl;
      destroy( head ); 
   }
}

