#include <iostream>
#include <sstream>
#include <string>
using namespace std;

// односвязный список
typedef struct node_single {           // структура узла
   struct node_single *next;
   int data;                           // данные узла
} node_single_t;

node_single_t *new_list( int level ) { // создание списка
   node_single_t *p = new node_single_t;
   p->data = level;                    // обратная нумерация
   p->next = level ? new_list( --level ) : NULL;
   return p;
}

void put_list( node_single_t *list, bool direct ) {
   if( !list ) return;
   if( direct ) cout << list->data << " , ";
   put_list( list->next, direct );     // на уровень вглубь
   if( !direct ) cout << list->data << " , ";
}

string show_list( node_single_t *list, bool direct ) {
   if( !list ) return string( "" ); 
   ostringstream out;
   out << list->data << " , ";
   string own = out.str();
   return direct ? show_list( list->next, direct ) + own :
                   own + show_list( list->next, direct ); 
}

void destroy( struct node_single *p ) {
   if( p->next ) destroy( p->next );
   delete p;                           // удалить в обратном порядке
}

int main( int argc, char **argv ) {
   while( true ) {
      int size;
      cout << "длина списка: ";
      cin >> size;
      struct node_single *head = new_list( size );
      cout << "нисходящая рекурсия: " << show_list( head, false ) << endl; 
      cout << "восходящая рекурсия: " << show_list( head, true ) << endl;
      destroy( head );                 // уничтожение списка
   }
   return 0;
}

