#include <iostream>
#include <cstdint>
using namespace std;

typedef int8_t a3[ 3 ];
typedef int8_t a5[ 5 ];        

struct multy {
   static const uint bytes = sizeof( a3 ) * sizeof( a5 ); 
   union {
      int8_t   u1[ bytes ];                // 15 шт.
      a3       u3[ bytes / sizeof( a3 ) ]; // 5 шт. по 3 байт
      a5       u5[ bytes / sizeof( a5 ) ]; // 3 шт. по 5 байт
   };
};

int main( int argc, char **argv ) {
   struct multy m;
   for( uint i = 0; i < multy::bytes; i++ ) 
      m.u1[ i ] = i + 1;
   int8_t *b = &m.u1[ 0 ], *p = b;
   for( uint i = 0; i < multy::bytes; i++ ) {
      cout << (int)*p++ << " , ";
   }
   cout << endl;
   a3* s = (a3*)b;
   for( uint i = 0; i < multy::bytes / sizeof( a3 ); i++ ) {
      p = (int8_t*)s++;   // инкремент без выравнивания (+3)
      cout << (int)*p << " , ";
   }
   cout << endl;
   a5* f = (a5*)b;
   for( uint i = 0; i < multy::bytes / sizeof( a5 ); i++ ) {
      p = (int8_t*)f++;   // инкремент без выравнивания (+5)
      cout << (int)*p << " , ";
   }
   cout << endl;
   return 0;
}
